class SongPlayer
{
   var target;
   var songUrl;
   var loader;
   var mp3Song;
   var weirdClipVeryFirstFrame;
   var currentPos;
   var weirdClipResume;
   var isPlaying;
   var lagLoops;
   function SongPlayer(target)
   {
      var s = this;
      this.target = target;
      target.onEnterFrame = function()
      {
         s.doWork();
      };
      this.songUrl = null;
      this.loader = new MovieClipLoader();
      var _loc2_ = new Object();
      _loc2_.onLoadInit = function(mc)
      {
         fscommand("duration",s.getDuration());
         s.setPlaying(true);
      };
      _loc2_.onLoadError = function(mc, errorCode)
      {
         s.setPlaying(false);
      };
      this.loader.addListener(_loc2_);
   }
   function loadAndPlay(url)
   {
      this.resetSong();
      this.songUrl = url;
      if(url != null)
      {
         if(this.IsMP3())
         {
            var s = this;
            this.mp3Song = new Sound();
            this.mp3Song.onLoad = function(success)
            {
               if(success)
               {
                  fscommand("duration",s.getDuration());
                  s.setPlaying(true);
               }
               else
               {
                  fscommand("error",null);
               }
            };
            this.mp3Song.loadSound(url,true);
         }
         else
         {
            this.weirdClipVeryFirstFrame = true;
            this.target.createEmptyMovieClip("songMC",this.target.getNextHighestDepth());
            this.loader.loadClip(url,this.target.songMC);
         }
      }
   }
   function playSong()
   {
      this.setPlaying(true);
      if(this.IsMP3())
      {
         this.mp3Song.start(this.currentPos / 12,0);
      }
      else if(this.weirdClipResume)
      {
         this.loadAndPlay(this.songUrl);
      }
      else
      {
         this.target.songMC.play();
      }
   }
   function pauseSong()
   {
      if(this.IsMP3())
      {
         this.mp3Song.stop();
      }
      else if(this.IsWeirdClip())
      {
         this.resetSong();
         this.weirdClipResume = true;
      }
      else
      {
         this.target.songMC.stop();
      }
      this.setPlaying(false);
   }
   function getPosition()
   {
      return Math.floor(this.currentPos / 12);
   }
   function setPosition(pos)
   {
      this.currentPos = pos * 12;
      if(this.IsMP3())
      {
         if(this.isPlaying)
         {
            this.mp3Song.start(pos,0);
         }
      }
      else
      {
         if(this.IsWeirdClip())
         {
            return undefined;
         }
         if(this.isPlaying)
         {
            this.target.songMC.gotoAndPlay(this.currentPos);
         }
         else
         {
            this.target.songMC.gotoAndStop(this.currentPos);
         }
      }
   }
   function setPlaying(isPlaying)
   {
      this.isPlaying = isPlaying;
   }
   function getDuration()
   {
      if(this.IsMP3())
      {
         return Math.floor(this.mp3Song.duration / 1000);
      }
      if(this.IsWeirdClip())
      {
         return 30;
      }
      return Math.floor(this.target.songMC._totalframes / 12);
   }
   function doWork()
   {
      if(!this.isPlaying)
      {
         return undefined;
      }
      var _loc2_ = 0;
      if(this.IsMP3())
      {
         _loc2_ = this.mp3Song.position / 83.333333;
      }
      else if(!this.IsWeirdClip())
      {
         _loc2_ = this.target.songMC._currentframe;
      }
      else
      {
         if(this.weirdClipVeryFirstFrame)
         {
            _loc2_ = this.target.songMC._currentframe;
         }
         else
         {
            _loc2_ = this.currentPos + 1;
         }
         this.weirdClipVeryFirstFrame = false;
      }
      if(_loc2_ > 0 && _loc2_ == this.currentPos)
      {
         if(++this.lagLoops >= 60)
         {
            this.setPlaying(false);
            fscommand("error");
            return undefined;
         }
      }
      else
      {
         this.lagLoops = 0;
      }
      var _loc3_ = false;
      if(Math.floor(this.currentPos / 12) != Math.floor(_loc2_ / 12))
      {
         _loc3_ = true;
      }
      this.currentPos = _loc2_;
      if(_loc3_)
      {
         fscommand("position",Math.floor(this.currentPos / 12));
      }
      if(this.IsMP3())
      {
         if(this.mp3Song.position >= this.mp3Song.duration)
         {
            this.pauseSong();
         }
      }
      else
      {
         var _loc4_ = !this.IsWeirdClip() ? this.target.songMC._totalframes : 360;
         if(this.currentPos >= _loc4_)
         {
            this.pauseSong();
         }
      }
   }
   function resetSong()
   {
      this.currentPos = 0;
      this.isPlaying = false;
      this.loader.unloadClip(this.target.songMC);
      this.mp3Song.stop();
      this.mp3Song.position = 0;
      this.weirdClipResume = false;
      this.lagLoops = 0;
   }
   function IsMP3()
   {
      return this.songUrl.substr(this.songUrl.length - 3,3).toLowerCase() == "mp3";
   }
   function IsWeirdClip()
   {
      return this.target.songMC._totalframes < 300;
   }
}
